<template>
  <header>
    <nav class="row">
      <div class="col-3">
        <h1 class="title" @click="switchToHomeView"><router-link class="link" to="/">Egeriec</router-link></h1>
      </div>
      <div class="col-9 nav-bar">
        <ul class="nav justify-content-end">
          <li class="nav-item">
            <router-link class="link" to="/" @click="switchToDiagnosticView">diagnostic</router-link>
          </li>
          <li class="nav-item">
            <router-link class="link" to="/decision-tool" @click="switchToToolView">tool</router-link>
          </li>
        </ul>
      </div>
    </nav>
    <div class="spinner" v-if="currentSpinner > 0">
      <i class="fa fa-spinner fa-pulse fa-lg fa-fw" aria-hidden="true"></i>
      <span class="sr-only">loading</span>
    </div>
  </header>
</template>

<script lang="ts">
import {ref, defineComponent, computed} from 'vue'
import { useStore } from '@/store'

type Flavour = 'diagnostic' | 'tool';

export default defineComponent({
  name: 'Header',
  setup: () => {
    const flavour = ref<Flavour>('diagnostic')

    const store = useStore();

    const switchToToolView = () => {
      store.commit('switchSidebarContent', 'tool');
      store.commit('setBackgroundLayer', 'ortho');
    }

    const switchToDiagnosticView = () => {
      store.commit('switchSidebarContent', 'diagnostic');
      store.commit('setBackgroundLayer', 'osm');
    }

    const switchToHomeView = () => {
      location.reload()
    }

    return {
      flavour,
      currentSpinner: computed(() => store.state.spinner),
      switchToHomeView,
      switchToToolView,
      switchToDiagnosticView
    }
  }
})
</script>

